/***************************************************************************
* PostTrain.h                                                              *
*                                                                          *
*   Changes:                                                               *
*                                                                          *
*       08/15/99  arvo    Removed all fixed-length arrays.                 *
*       08/06/99  arvo    Major cleanup.                                   *
*       01/05/97  guo     Initial codiing.                                 *
*                                                                          *
*--------------------------------------------------------------------------*
* Copyright (C) 1999, James Arvo                                           *
*                                                                          *
* This program is free software; you can redistribute it and/or modify it  *
* under the terms of the GNU General Public License as published by the    *
* Free Software Foundation.  See http://www.fsf.org/copyleft/gpl.html      *
*                                                                          *
* This program is distributed in the hope that it will be useful, but      *
* WITHOUT EXPRESS OR IMPLIED WARRANTY of merchantability or fitness for    *
* any particular purpose.  See the GNU General Public License for more     *
* details.                                                                 *
*                                                                          *
***************************************************************************/
#ifndef __POST_TRAIN_INCLUDED__
#define __POST_TRAIN_INCLUDED__

#include <rec/FeatureRecognizer.h>

extern void WriteFeatureMatrix( 
    const char *dir_name,       // The directory holding the training files.
    const List &feature_stats,  // List of FeatureStatVectors for all the symbols.
    int level                   // Nesting level (for printing data about progress).
    );

#endif










