/* *************************************************************************
* Copyright (c) 1999, Steve Smithies                                       *
*                                                                          *
* This program is free software; you can redistribute it and/or modify it  *
* under the terms of the GNU General Public License as published by the    *
* Free Software Foundation.  See http://www.fsf.org/copyleft/gpl.html      *
*                                                                          *
* This program is distributed in the hope that it will be useful, but      *
* WITHOUT EXPRESS OR IMPLIED WARRANTY of merchantability or fitness for    *
* any particular purpose.  See the GNU General Public License for more     *
* details.                                                                 *
*                                                                          *
***************************************************************************/
#ifndef _COMBOS_H_
#define _COMBOS_H_

typedef int ComboSequence;

typedef struct COMBOS_T {
  int Number;
  ComboSequence **Sequence;
} Combos;

void Generate(int N, Combos *Generated, int Maximum);
int Combo_Size(Combos *Com);
void Print_Seq(ComboSequence *S);
void Print_Combos(Combos *C);
void Get_Seq(Combos *Com, ComboSequence *Ret, int N);
int Seq_Length(ComboSequence *S);

#endif
